#pragma once
#ifndef DEVICES
#define DEVICES

#include <SDL/SDL.h>

#define XR_KEY_ESCAPE 27
#define XR_KEY_SPACE 32

#define XR_KEY_a 97
#define XR_KEY_b 98
#define XR_KEY_c 99
#define XR_KEY_d 100
#define XR_KEY_e 101
#define XR_KEY_f 102
#define XR_KEY_g 103
#define XR_KEY_h 104
#define XR_KEY_i 105
#define XR_KEY_j 106
#define XR_KEY_k 107
#define XR_KEY_l 108
#define XR_KEY_m 109
#define XR_KEY_n 110
#define XR_KEY_o 111
#define XR_KEY_p 112
#define XR_KEY_q 113
#define XR_KEY_r 114
#define XR_KEY_s 115
#define XR_KEY_t 116
#define XR_KEY_u 117
#define XR_KEY_v 118
#define XR_KEY_w 119
#define XR_KEY_x 120
#define XR_KEY_y 121
#define XR_KEY_z 122

#define XR_KEY_UP 273
#define XR_KEY_DOWN 274
#define XR_KEY_RIGHT 275
#define XR_KEY_LEFT 276

#define XR_KEY_KP0 256
#define XR_KEY_KP1 257
#define XR_KEY_KP2 258
#define XR_KEY_KP3 259
#define XR_KEY_KP4 260
#define XR_KEY_KP5 261
#define XR_KEY_KP6 262
#define XR_KEY_KP7 263
#define XR_KEY_KP8 264
#define XR_KEY_KP9 265

#define XR_KEY_F1 282
#define XR_KEY_F2 283
#define XR_KEY_F3 284
#define XR_KEY_F4 285
#define XR_KEY_F5 286
#define XR_KEY_F6 287
#define XR_KEY_F7 288
#define XR_KEY_F8 289
#define XR_KEY_F9 290
#define XR_KEY_F10 291
#define XR_KEY_F11 292
#define XR_KEY_F12 293

#define XR_KEY_RSHIFT 303
#define XR_KEY_LSHIFT 304
#define XR_KEY_RCTRL 305
#define XR_KEY_LCTRL 306
#define XR_KEY_RALT 307
#define XR_KEY_LALT 308

#define XR_MOUSE_BUTTON_LEFT 1
#define XR_MOUSE_BUTTON_MIDDLE 2
#define XR_MOUSE_BUTTON_RIGHT 3
#define XR_MOUSE_WHEELUP 4
#define XR_MOUSE_WHEELDOWN 5

struct Xr_MouseDesc
{
	Xr_MouseDesc() : button(new bool[8]), posX(0), posY(0), relX(0), relY(0), oldPosX(0), oldPosY(0)
	{
		int i;
		for(i = 0; i < 8; i++)
		{
			button[i] = false;
		}
	}
	
	~Xr_MouseDesc()
	{
		delete[] button;
	}
	
	bool *button;
	int posX;
	int posY;
	int relX;
	int relY;
	int oldPosX;
	int oldPosY;
};

struct Xr_KeyboardDesc
{
	Xr_KeyboardDesc() : key(new bool[SDLK_LAST])
	{
		int i;
		for(i = 0; i < SDLK_LAST; i++)
		{
			key[i] = false;
		}
	}
	
	~Xr_KeyboardDesc()
	{
		delete[] key;
	}
	
	bool *key;
};

struct Xr_DevicesDesc
{
	Xr_DevicesDesc() : mouse(new Xr_MouseDesc), keyboard(new Xr_KeyboardDesc), windowHeight(0), windowWidth(0)
	{
	}
	
	~Xr_DevicesDesc()
	{
		delete mouse;
		delete keyboard;
	}
	
	Xr_MouseDesc *mouse;
	Xr_KeyboardDesc *keyboard;
	
	int windowHeight;
	int windowWidth;
};

#endif
