#pragma once
#ifndef MATRIX
#define MATRIX

class Xr_MATRIX_4X4
{
	public:
		Xr_MATRIX_4X4();
		Xr_MATRIX_4X4(float*);
		Xr_MATRIX_4X4(Xr_MATRIX_4X4 const&);
		~Xr_MATRIX_4X4();
		
		/* Valeur de retour en lecture seul */
		float* const getValues() const;
		
		void loadIdentity();
		void loadProjection(float, float, float, float);
		void lookAt(float, float, float, float, float, float, float, float, float);
		void translate(float, float, float);
		void rotate(float, float, float, float);
		void scale(float, float, float);

		Xr_MATRIX_4X4& operator=(Xr_MATRIX_4X4 const& matrix);
		Xr_MATRIX_4X4 operator*(Xr_MATRIX_4X4 const& matrix);
		
	private:
		float *M_values;
};

#endif
