#pragma once
#ifndef RENDER
#define RENDER

#include "scene.h"

class Xr_Renderer
{
	public:
		Xr_Renderer();
		~Xr_Renderer();
		
		static Xr_Renderer* getInstance();
		static bool instanced();
		static void quitInstance();
		
		void init(unsigned int, unsigned int, bool, unsigned int);
		void mainLoop();
		
		void setVideo(unsigned int, unsigned int, bool);
		void setFrameRateLimite(unsigned int);
		void setImageSize(unsigned int, unsigned int);
		
		void setScene(Xr_Scene*);
		
		unsigned int getWindowWidth() const;
		unsigned int getWindowHeight() const;
		unsigned int getImageWidth() const;
		unsigned int getImageHeight() const;
		unsigned int getFrameRate() const;
		
	private:
		static Xr_Renderer* R_instance;
		bool isInit;
		unsigned int R_windowWidth;
		unsigned int R_windowHeight;
		unsigned int R_imageWidth;
		unsigned int R_imageHeight;
		bool R_fullscreen;
		unsigned int R_frameRateLimite;
		unsigned int R_frameRate;
		Xr_Scene *R_scene;
};

#endif
