#pragma once
#ifndef SCENE
#define SCENE

#include <vector>

#include "program.h"
#include "object.h"
#include "matrix.h"
#include "light.h"
#include "camera.h"


class Xr_Scene
{
	public:
		Xr_Scene();
		~Xr_Scene();

		void addObject(Xr_Object*);
		void deleteObject(Xr_Object*);
		void addLight(Xr_Light*);
		void deleteLight(Xr_Light*);
		void attachCamera(Xr_Camera*);
		void detachCamera();
		void draw();

	private:
		std::vector<Xr_Object*> S_objectList;
		std::vector<Xr_Light*> S_lightList;
		Xr_MATRIX_4X4 *modelview;
		Xr_Camera *S_camera;

		Xr_Program *basicProg;
		Xr_Program *render1Prog;
};

#endif
