#include "event.h"

#include "debug.h"
#include "render.h"

/* class Xr_EventProfil */

Xr_EventProfil::Xr_EventProfil()
{
}

Xr_EventProfil::~Xr_EventProfil()
{
}

void Xr_EventProfil::execute(Xr_DevicesDesc *devices)
{
}

/* class Xr_EventManager */

Xr_EventManager* Xr_EventManager::E_instance = 0;

Xr_EventManager::Xr_EventManager() : E_eventProfil(0), E_devices(new Xr_DevicesDesc), E_event(new SDL_Event), E_mouseCapture(false), E_quit(false)
{
}

Xr_EventManager::~Xr_EventManager()
{
	delete E_devices;
	delete E_event;
}

Xr_EventManager* Xr_EventManager::getInstance()
{
	if(E_instance)
	{
		return E_instance;
	}
	else
	{
		E_instance = new Xr_EventManager;
		return E_instance;
	}
}

bool Xr_EventManager::instaced()
{
	if(E_instance)
	{
		return true;
	}
	else
	{
		return false;
	}
}

void Xr_EventManager::quitInstance()
{
	if(E_instance)
	{
		delete E_instance;
	}
}

void Xr_EventManager::setProfil(Xr_EventProfil *profil)
{
	if(profil)
	{
		E_eventProfil = profil;
	}
	else
	{
		Xr_Log("Xr_EventManager : Le profil est invalide");
	}
}

void Xr_EventManager::updateDeviceState()
{
	E_devices->mouse->relX = 0;
	E_devices->mouse->relY = 0;
	
	E_devices->windowHeight = 0;
	E_devices->windowWidth = 0;
	
	while(SDL_PollEvent(E_event))
	{
		switch(E_event->type)
		{
			case SDL_VIDEORESIZE:
				E_devices->windowHeight = E_event->resize.h;
				E_devices->windowWidth = E_event->resize.w;
	
			case SDL_KEYDOWN:
				E_devices->keyboard->key[E_event->key.keysym.sym] = true;
				break;
				
			case SDL_KEYUP:
				E_devices->keyboard->key[E_event->key.keysym.sym] = false;
				break;
				
			case SDL_MOUSEMOTION:
				E_devices->mouse->oldPosX = E_devices->mouse->posX;
				E_devices->mouse->oldPosY = E_devices->mouse->posY;
				
				E_devices->mouse->posX = E_event->motion.x;
				E_devices->mouse->posY = E_event->motion.y;
				
				E_devices->mouse->relX = E_devices->mouse->posX - E_devices->mouse->oldPosX;
				E_devices->mouse->relY = E_devices->mouse->posY - E_devices->mouse->oldPosY;
				if(E_mouseCapture)
				{
					if(E_devices->mouse->posX >= Xr_Renderer::getInstance()->getWindowWidth() - 30 || E_devices->mouse->posX <= 30 || E_devices->mouse->posY >= Xr_Renderer::getInstance()->getWindowHeight() - 20 || E_devices->mouse->posY <=  20)
					{
						SDL_WarpMouse((Xr_Renderer::getInstance()->getWindowWidth() / 2), (Xr_Renderer::getInstance()->getWindowHeight() / 2));
						E_devices->mouse->posX = (Xr_Renderer::getInstance()->getWindowWidth() / 2);
						E_devices->mouse->posY = (Xr_Renderer::getInstance()->getWindowHeight() / 2);
					}
				}
				break;
				
			case SDL_MOUSEBUTTONDOWN:
				E_devices->mouse->button[E_event->button.button] = true;
				break;
				
			case SDL_MOUSEBUTTONUP:
				E_devices->mouse->button[E_event->button.button] = false;
				break;
				
			case SDL_QUIT:
				E_quit = true;
				break;
				
			default:
				break;
		}
	}
}

void Xr_EventManager::executeProfil()
{
	if(E_eventProfil)
	{
		E_eventProfil->execute(E_devices);
	}
}

bool Xr_EventManager::quitEvent()
{
	return E_quit;
}

void Xr_EventManager::genQuitEvent()
{
	E_quit = true;
}

void Xr_EventManager::enableMouseCapture()
{
	if(!E_mouseCapture)
	{
		SDL_WM_GrabInput(SDL_GRAB_ON);
		SDL_ShowCursor(SDL_DISABLE);
		E_mouseCapture = true;
	}
}

void Xr_EventManager::disableMouseCapture()
{
	if(E_mouseCapture)
	{
		SDL_WM_GrabInput(SDL_GRAB_OFF);
		SDL_ShowCursor(SDL_ENABLE);
		E_mouseCapture = false;
	}
}

bool Xr_EventManager::mouseCaptured()
{
	return E_mouseCapture;
}
