#include "plane.h"

Xr_Plane::Xr_Plane()
{
}

Xr_Plane::Xr_Plane(Xr_Vector3D const& p1, Xr_Vector3D const& p2, Xr_Vector3D const& p3)
{
	setPoints(p1, p2, p3);
}

Xr_Plane::Xr_Plane(Xr_Vector3D const& normal, Xr_Vector3D const& point)
{
	setNormalPoint(normal, point);
}

Xr_Plane::~Xr_Plane()
{
}

void Xr_Plane::setPoints(Xr_Vector3D const& p1, Xr_Vector3D const& p2, Xr_Vector3D const& p3)
{
	P_normal = (p3 - p2) * (p1 - p2);
	P_normal.normalize();
	
	P_point = p2;
	P_d = -(Xr_Vector3D::dot(P_normal, P_point));
}

void Xr_Plane::setNormalPoint(Xr_Vector3D const& normal, Xr_Vector3D const& point)
{
	P_normal = normal;
	P_normal.normalize();
	P_point = point;
	P_d = -(Xr_Vector3D::dot(P_normal, P_point));
}

float Xr_Plane::getDistanceToPoint(Xr_Vector3D const& point)
{
	float distance = (P_d + Xr_Vector3D::dot(P_normal, point));
	return distance;
}

void Xr_Plane::flipNormal()
{
	P_normal = -P_normal;
}

Xr_Vector3D Xr_Plane::getNormal()
{
	return P_normal;
}
